#include "effect_cycle.h"
#include "effects.h"

CycleEffect::CycleEffect() {
	changeEffect();
}

CycleEffect::~CycleEffect() {
	delete effect;
}

void CycleEffect::changeEffect() {
    int new_id;
    if (EFFECT_CYCLE_RANDOM) {
        do {
            new_id = random8(cycle_effects_count);
        } while (new_id == effect_id);
    } else {
        new_id = (effect_id + 1) % cycle_effects_count;
    }
    LOGln("CycleEffect * Changing effect from #%d to #%d", effect_id, new_id);
    delay(25);
    if (effect) delete effect;
    LOGln("CycleEffect * Searching for new effect '%s'", cycle_effects[new_id]);
    delay(25);
    effect = string_to_effect(cycle_effects[new_id]);
    effect_id = new_id;
    effectSince = millis();
}

boolean CycleEffect::can_be_shown_with_clock() {
    return effect->can_be_shown_with_clock();
};
boolean CycleEffect::clock_as_mask() {
    return effect->clock_as_mask();
};

void CycleEffect::loop() {
    if (!effect) changeEffect(); // If this is the first run, we have to select an effect first!
    effect->loop();
    // Don't use EVERY_N_SECONDS(config_effect_cycle_time) here because that function isn't relly made
    // to be used with changing values.
    EVERY_N_SECONDS(1) {
        if (effectSince + EFFECT_CYCLE_TIME*1000 < millis()) {
            changeEffect();
        }
    }
}
