#include <ArduinoOTA.h>

#include "my_wifi.h"
#include <ArduinoOTA.h>
#include "config.h"
#include "prototypes.h"

void ota_setup() {
	ArduinoOTA.onStart([]() {
		String type;
		if (ArduinoOTA.getCommand() == U_FLASH)
		type = "sketch";
		else // U_SPIFFS
		type = "filesystem";

		// NOTE: if updating SPIFFS this would be the place to unmount SPIFFS using SPIFFS.end()
		Serial.println("OTA * Start updating " + type);
	});
	ArduinoOTA.onEnd([]() {
		Serial.println("\nOTA * End");
	});
	ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
		Serial.printf("OTA * Progress: %u%%\r", (progress / (total / 100)));
	});
	ArduinoOTA.onError([](ota_error_t error) {
		Serial.printf("OTA * Error[%u]: ", error);
		if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
		else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
		else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
		else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
		else if (error == OTA_END_ERROR) Serial.println("End Failed");
	});

	LOGln("OTA * Starting OTA with client_id %s", hostname);
	ArduinoOTA.setHostname(hostname);
	ArduinoOTA.begin();
}

void ota_loop() {
	ArduinoOTA.handle();
}
